//+------------------------------------------------------------------+
//|                                                     Patient1.mq4 |
//|                                       Copyright  2006, Aaragorn |
//|                   http://www.forex-tsd.com/members/aaragorn.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Aaragorn"
#property link      "http://www.forex-tsd.com/members/aaragorn.html"
//
/* System specific */
//
string SystemName = "Patient 1";
double version = 1;
extern int MagicNumber=135797531;    // Magic Number -- change for every pair traded
#include <stdlib.mqh>

//---- User defined indicator parameters
extern int                  MaxTradesAllowed = 16;
extern double                     TakeProfit = 1000;
extern double                        MaxLots = 10; // lots smaller than 1 must have "0.x", don't forget the zero left of the decimal
extern double                 LotAccelerator = 0.03; // degree of lot acceleration
extern double                   TriggerShift = 1; // zero uses the current forming bar, 1 uses the first completed bar
extern string            Envelope_Parameters = "Envelope_Parameters";
extern double                     AveragingP =  10;
extern double                       ma_shift =  0;
extern double                      Deviation =  0.47;
extern string                 ADX_Parameters = "ADX_Parameters";
extern double                      ADXPeriod =  10; 
extern string Dynamic_Trailing_Stop_Settings = "Dynamic Trailing Stop Settings";
extern bool               EnableTrailingStop = true; // Enable Dynamic Trailing Stop
extern double             TrailingStopFactor = 1.45;
extern string                  Auto_StopLoss = "Auto StopLoss";
extern double                  StopLossIndex = 2.5;
extern bool                AutoStopLossIndex = true;
extern string                Manual_StopLoss = "Manual overrides Auto StopLoss unless = 0";
extern double                 ManualStopLoss = 0;  //0 allows for auto stop loss
extern double                      StopLevel = 0;
extern string      Additional_User_Functions = "Additional User Functions";
extern bool                        UseAlerts = false; //Gives Audio and pop up Alert when Patient1 enters a position
//extern bool         DynamicTrailManualTrades = false; //Allows Patient1 Dynamic Trailing Stop to Manage Manually Opened Orders on the same currency pair
extern bool                    UseExitMarket = false;         
//---- indicator variables
double Closing=0,Closing1=0,EMA=0,EMA1=0,UpperE=0,LowerE=0,UpperE1=0,LowerE1=0;
double ADX=0,DIminus=0,DIplus=0,ADX1=0,DIminus1=0,DIplus1=0;

//----  variables for storing market information         
double ModeSpread=0,ModeStopLevel=0,ModePoint=0,Disperce=0;

//---- order management variables
int ticket, total, cnt;
double  StopLoss=0,SlipPage=0,Lots=0;

//---- order control variables
bool              OpenLong = false;
bool             OpenShort = false;


// Dynamic Trailing stop (TS) global variables
double PrevBuyStop=0,BuyStop=0;
double PrevSellStop=0,SellStop=0,TrailingStop=0;

#define DECISION_BUY 1
#define DECISION_SELL 0
#define DECISION_UNKNOWN -1
//----
double ValuePeriod = 1;                      // Step of period in minutes
double ValuePeriodPrev = 1;
int FoundOpenedOrder = false;
bool DisablePipsator = false;
double BidPrev = 0;
double AskPrev = 0;
extern double ValuesPeriodCount = 7;
// Variables for evaluating the quality of the simulation
double BuyPossibilityQuality;
double SellPossibilityQuality;
double UndefinedPossibilityQuality;
//double BuyPossibilityQualityMid;
double PossibilityQuality;
double QualityMax = 0;
//----
double BuySucPossibilityQuality;
double SellSucPossibilityQuality;
double UndefinedSucPossibilityQuality;
double PossibilitySucQuality;
//----
double ModelingPeriod;                       // Period of simulation in the minutes
double ModelingBars;                         // Quantity of steps in the period
//----
double Spread;                               // Spread
double Decision;
double DecisionValue;
double PrevDecisionValue;
//----
double BuyPossibility;
double SellPossibility;
double UndefinedPossibility;
double BuyPossibilityPrev;
double SellPossibilityPrev;
double UndefinedPossibilityPrev;
//----
double BuySucPossibilityMid;                 // Average probability of the successful purchase
double SellSucPossibilityMid;                // Average probability of successful sale
double UndefinedSucPossibilityMid;           // Average successful probability of the indeterminate state
//----
double SellSucPossibilityCount;              // Count of probabilities of successful sale
double BuySucPossibilityCount;               // Count of probabilities of the successful purchase
double UndefinedSucPossibilityCount;         // Count of probabilities of the indeterminate state
//----
double BuyPossibilityMid;                    // Average probability of the purchase
double SellPossibilityMid;                   // Average probability of sale
double UndefinedPossibilityMid;              // Average probability of the indeterminate state
//----
double BuyPossibilityCount;                  // Count of probabilities of purchase
double SellPossibilityCount;                 // Count of probabilities of sale
double UndefinedPossibilityCount;            // Count of probabilities of the indeterminate state
//----

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    ModelingPeriod = ValuePeriod * ValuesPeriodCount;              // Period of simulation in minutes
   if (ValuePeriod != 0 )
       ModelingBars = ModelingPeriod / ValuePeriod;               // Quantity of steps in the period
   CalculateSpread();  
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| We calculate the actual value of spread (returned functions on   |
//| the market can give the incorrect actual value of spread if the  |
//| broker varies the value of spread                                |
//+------------------------------------------------------------------+

int CalculateSpread()
  {
   Spread = Ask - Bid;
   return (0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   //----we establish the Indicators
      
      Closing = iClose(NULL,0,TriggerShift);
      UpperE = iEnvelopes(NULL,0,AveragingP,MODE_EMA,ma_shift,PRICE_CLOSE,Deviation,MODE_UPPER,TriggerShift);
      LowerE = iEnvelopes(NULL,0,AveragingP,MODE_EMA,ma_shift,PRICE_CLOSE,Deviation,MODE_LOWER,TriggerShift);
      ADX = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,TriggerShift);
      DIplus = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,TriggerShift);
      DIminus = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,TriggerShift);   

      //---- shifted previous 1 bar
      Closing1 = iClose(NULL,0,TriggerShift+1);
      UpperE1 = iEnvelopes(NULL,0,AveragingP,MODE_EMA,ma_shift,PRICE_CLOSE,Deviation,MODE_UPPER,TriggerShift+1);
      LowerE1 = iEnvelopes(NULL,0,AveragingP,MODE_EMA,ma_shift,PRICE_CLOSE,Deviation,MODE_LOWER,TriggerShift+1);
      ADX1 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,TriggerShift+1);
      DIplus1 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,TriggerShift+1);
      DIminus1 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,TriggerShift+1);
      
     //--- we get market information
      ModeSpread = MarketInfo(Symbol(), MODE_SPREAD);
      ModeStopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
      ModePoint = MarketInfo(Symbol(), MODE_POINT);
  
      //----we manage any open orders
      //Print("call exit");
      ExitMarket();
      //Print("call trailstop");
      DynamicTrailStop();
      
      //----we define the rules for opening orders 

      OpenLong = false;
      OpenShort = false;  
      if(Closing > UpperE && Closing1 < UpperE1  && DIplus > DIminus)
         {
         OpenLong = true;
         //Print("Open long true @ ",TimeHour(CurTime()),"  Minute: ",TimeMinute(CurTime()) );
         }
         
      if(Closing < LowerE && Closing1 > LowerE1  && DIplus < DIminus)
         {
         OpenShort = true;
         //Print("Open short true @ ",TimeHour(CurTime()),"  Minute: ",TimeMinute(CurTime()) );
         }
     
      //----we set stop loss and enter the market
      Patient1Decision();
      AutoStopLossIndex();
      CalculateLots();      
      EnterMarket();
      

  return(0);//repeat for next tick
}//int start
//+----------------------------Functions--------------------------------------+
//+------------------------------------------------------------------+
//|  We calculate Lots                            |
//+------------------------------------------------------------------+
double CalculateLots()
{
   Lots = NormalizeDouble(AccountFreeMargin()/(LotAccelerator*1000/0.1),1);
   if(Lots < 0.01) Lots = 0.01;
   if(Lots > MaxLots) Lots = MaxLots;
  // Lots = MaxLots;

   return (Lots);
}
//+------------------------------------------------------------------+
//| Entrance into the market                                         |
//+------------------------------------------------------------------+

int EnterMarket()
{
   // We limit the number of open orders allowed to enter into the market
   total = OrdersTotal();
   if(total < MaxTradesAllowed)
      {
           // We count the dispersion 
           Disperce = (iHigh(Symbol(), 0, 0) - iLow(Symbol(), 0, 0));
           if(OpenShort == true)
               {
               // Calculation of the stoploss
                   if((Ask + BuySucPossibilityMid*StopLossIndex + ModeSpread * Point) < 
                      (Ask + ModeStopLevel* ModePoint+ ModeSpread * Point))
                     {
                       StopLoss = Ask + ModeStopLevel* ModePoint+ ModeSpread * Point + Disperce;
                     }
                   else
                     {
                       if(BuySucPossibilityMid != 0)
                           StopLoss = Ask + BuySucPossibilityMid*StopLossIndex + 
                                      ModeSpread * Point+ Disperce;
                       else
                           StopLoss = Ask + ModeStopLevel* ModePoint+ ModeSpread * Point + 
                                      Disperce;
                     }
                  if(ManualStopLoss > 0) 
                     {
                     StopLoss = Ask + (ManualStopLoss * Point);
                     }  
                  StopLevel = StopLoss;     
                //---- Open Short Order
                ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, SlipPage, StopLoss, Bid - (TakeProfit * Point), "Order by Patient1", MagicNumber, 0, Green);
                   if(ticket > 0)
                     {
                       if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                       {
                        OpenShort = false;
                        PrevSellStop = OrderStopLoss();
                        if(UseAlerts==true)
                           {
                           PlaySound("alert.wav");
                           Alert("Patient1 Alert --- Selling ",Lots," EURUSD @ ",Bid);
                           }
                        }
                     }                             
                     else
                     {
                       Print("Error on the Short Entry: ",GetLastError());
                       PrintErrorValues();
                     }
                   return (0);
               }//ifopenshort
               if(OpenLong == true)
                  {
                   // Calculation of the stoploss
                   if((Bid - SellSucPossibilityMid*StopLossIndex- ModeSpread* Point) > 
                      (Bid - ModeStopLevel* ModePoint- ModeSpread* Point))
                     {
                       StopLoss = Bid - ModeStopLevel* ModePoint- ModeSpread* Point - Disperce;
                     }
                   else
                     {
                       if(SellSucPossibilityMid != 0)
                           StopLoss = Bid - SellSucPossibilityMid*StopLossIndex- 
                                      ModeSpread* Point- Disperce;
                       else
                           StopLoss = Bid - ModeStopLevel* ModePoint- ModeSpread* Point- 
                                      Disperce;
                     }
                   if(ManualStopLoss > 0) 
                     {
                     StopLoss = Bid - (ManualStopLoss * Point);
                     }
                   StopLevel = StopLoss;    
                   //---- Open Long Order  
                   ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, SlipPage, StopLoss, Ask + (TakeProfit * Point), "NeuroCluster-testing-AI-LB1", MagicNumber, 0, Blue);
                     if(ticket > 0)
                       {
                        if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                        {
                           OpenLong=false;
                           PrevBuyStop = OrderStopLoss();
                           if(UseAlerts==true)
                             {
                             PlaySound("alert.wav");
                             Alert("Patient1 Alert --- Buying EURUSD ",Lots," EURUSD @ ",Ask);
                             }                        
                         }
                       }
                       else
                       {
                         Print("Error on the Long Entry: ",GetLastError());
                         PrintErrorValues();
                       }
                  return (0);  
                  }//ifopenlong
   }//maxtrades
return (0);
}//entermarket
//+------------------------------------------------------------------+
//| Automatic installation of the level of the stoploss              |
//+------------------------------------------------------------------+

int AutoStopLossIndex()
  {
   if(AutoStopLossIndex == true)
     {
       StopLossIndex = ModeSpread;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Dynamic Trailing Stop                                            |
//+------------------------------------------------------------------+
// Check to see if "EnableTrailingStop" is enabled..if not no need to execute
// Only Modify the "StopLevel" here, since the exits are executed on the next function ExitMarket()
// please make sure that the distance is >= 5 pips from the market, otherwise the stop order modification will be rejected.
// Thank you!
int DynamicTrailStop()
{
    //Print("answer call trailstop");
    if(EnableTrailingStop)
      {
       TrailingStop = (TrailingStopFactor * iATR(Symbol(), 0 , 14 , 1) );
       for(int cnt = 0; cnt < OrdersTotal(); cnt++)
         {
            bool DynamicTrailAllowed = true;
            OrderSelect(cnt, SELECT_BY_POS);
            if(OrderMagicNumber() != MagicNumber)//insures only Patient1 placed orders are dynamic trail stop managed
               {
               DynamicTrailAllowed = False;
               }    
            if(DynamicTrailAllowed && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && TrailingStop > 0)
               {
             /*  if(OrderType() == OP_BUY)// If order is a long position
                  {
                  BuyStop = Bid - TrailingStop;
                  if(BuyStop < PrevBuyStop) // We maintain the highest value
                     {
                     BuyStop = PrevBuyStop;
                     }
                  if(BuyStop > 0 && (Bid - BuyStop) >= Bid - (5 * Point)  && BuyStop > OrderStopLoss())// if new stop loss is allowed and higher than current stop loss
                     {
                     OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                     }
                  }
                  else 
                  {
                  if(OrderType() == OP_SELL)// If order is a short position
                     {
                     SellStop = Ask + TrailingStop;
                     if(SellStop > PrevSellStop) // We maintain the lowest value
                        {
                        SellStop = PrevSellStop;
                        }
                     if(SellStop > 0 && (SellStop - Ask) >= Ask + (5 * Point)  && SellStop < OrderStopLoss())// if new stop loss is allowed and lower than current stop loss
                        {
                        OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                        }
                     }//ifOT=S
                  }//ifOT=B*/
                           
                  if(OrderType() == OP_BUY)
                  {
                     BuyStop = Bid - TrailingStop;
                     if(BuyStop < PrevBuyStop) BuyStop = PrevBuyStop;
                     if(BuyStop > 0 && (Bid - BuyStop) >= 5 * Point && BuyStop > OrderStopLoss())
                        {
                        OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                        }
                  }
                  else 
                  {
                     if(OrderType() == OP_SELL)
                     {
                        SellStop = Ask + TrailingStop;
                        if(SellStop > PrevSellStop) SellStop = PrevSellStop;
                        if(SellStop > 0 && (SellStop - Ask) >= 5 * Point && SellStop < OrderStopLoss())
                           {
                           OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                           }
                     }
                  }

              }//ifDTA
         PrevBuyStop = BuyStop;
         PrevSellStop = SellStop;
      }//for
   }//ifEnableTS      
return (0);
}//DTS


  


//+------------------------------------------------------------------+
//| Exit from the market                                             |
//+------------------------------------------------------------------+

int ExitMarket() // -------------------- Working the open orders -------------------
{
   if(UseExitMarket)
   {
      total = OrdersTotal();
      for(int cnt = 0; cnt < OrdersTotal(); cnt++)
         {
          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            // We search for orders opened by this code on our currency
            if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)// if this code has an open order on this currency
               {
               //Print("found ticket: ",OrderTicket()," type: ",OrderType()," total open orders: ",cnt);
               if(OrderType()==OP_BUY)  // If the obtained order is by the acquisition of the currency
                  {
                     // We close when the direction reverses
                  /*   if(Closing < UpperE)
                        {
                        OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                            
                        Print("Patient1 closed long ticket ",OrderTicket()," on a reverse @: ",Bid," BECAUSE cls: ",Closing," < uprE: ",UpperE);
                        /*}
                        else
                        {
                        Print("stays open");*/
                     /*   int err;
                        err=GetLastError();
                        Print("error(",err,"): ",ErrorDescription(err));

                        return(0);                     
                        }*/
                     if(ADX < ADX1 && DIminus > DIminus1)
                        {
                        OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                            
                        Print("Patient1 closed long ticket ",OrderTicket()," on a reverse @: ",Bid," BECAUSE ADX: ",ADX," < ADX1: ",ADX1," && DI-: ",DIminus," > DI-(1): ",DIminus1);
                        /*}
                        else
                        {
                        Print("stays open");*/
                        int err2;
                        err2=GetLastError();
                        Print("error(",err2,"): ",ErrorDescription(err2));

                        return(0);
                        }   
                  }//ifbuy
             
               if(OrderType() == OP_SELL)  // If the obtained order is by the selling of the currency
                  {
                     // We close when the direction reverses
                   /*  if(Closing > LowerE)
                        {
                        OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                             
                        Print("Patient1 closed short ticket ",OrderTicket()," on a reverse @: ",Ask," BECAUSE cls: ",Closing," > lwrE: ",LowerE);
                        /*}
                        else
                        {
                        Print("stays open");*/
                     /*   int err3;
                        err3=GetLastError();
                        Print("error(",err3,"): ",ErrorDescription(err3));

                        return(0);

                        }*/
                     if(ADX < ADX1 && DIplus > DIplus1)
                        {
                        OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                             
                        Print("Patient1 closed short ticket ",OrderTicket()," on a reverse @: ",Ask," BECAUSE ADX: ",ADX," < ADX1: ",ADX1,"  && DI+: ",DIplus," > DI+(1): ",DIplus1);
                        /*}
                        else
                        {
                        Print("stays open");*/
                        int err4;
                        err4=GetLastError();
                        Print("error(",err4,"): ",ErrorDescription(err4));

                        return(0);
                        }
                  }//ifsell   
               }//if order is open  
         }//fororders 
   }         
return(0);        
}//exitmarket  
 
//+------------------------------------------------------------------+
//| Conclusion of errors with the entrance into the market           |
//+------------------------------------------------------------------+

int PrintErrorValues()
  {
   Print("ErrorValues:Symbol=", Symbol(),",Lots=",Lots, ",Bid=", Bid, ",Ask=", Ask,
         ",SlipPage=", SlipPage, "StopLoss=",StopLoss,",TakeProfit=", TakeProfit, "tp * point= ",(TakeProfit*Point));
   return (0);
  }  
  
  
//////the next 3 functions are combined with the init. and spread calculation to assign stop loss
//+------------------------------------------------------------------+
//| We make the decision    --used to assign stop loss                                           |
//+------------------------------------------------------------------+

int CalculatePossibility (int shift)
  {
   DecisionValue = iClose( Symbol(), 0, ValuePeriod * shift) - 
                   iOpen( Symbol(), 0, ValuePeriod * shift);
   PrevDecisionValue = iClose( Symbol(), 0, ValuePeriod * (shift+1)) - 
                       iOpen( Symbol(), 0, ValuePeriod * (shift+1));
   SellPossibility = 0;
   BuyPossibility = 0;
   UndefinedPossibility = 0;
   if(DecisionValue != 0)                                         // If the solution not definite
     {
       if(DecisionValue > 0)  //means current bar closed up       // If the solution in favor of sale
         {
                                                                  // Suspicion to the probability of sale
           if(PrevDecisionValue < 0)//means previous bar closed down   // Confirmation of the solution in favor of sale
             {
               Decision = DECISION_SELL;
               BuyPossibility = 0;
               SellPossibility = DecisionValue;
               UndefinedPossibility = 0;
             }
           else                                                   // Otherwise the solution is not determined
             {
               Decision = DECISION_UNKNOWN;
               UndefinedPossibility = DecisionValue;
               BuyPossibility = 0;
               SellPossibility = 0;
             }
         }
       else  //means current bar closed down                      // If the solution in favor of the purchase
         {
           if(PrevDecisionValue > 0) //means previous bar closed up// Confirmation of the solution in favor of buy
             {
               Decision = DECISION_BUY;
               SellPossibility = 0;
               UndefinedPossibility = 0;
               BuyPossibility = -1 * DecisionValue;
             }
           else                                                   // The solution is not determined
             {
               Decision = DECISION_UNKNOWN;
               UndefinedPossibility = -1 * DecisionValue;
               SellPossibility = 0;
               BuyPossibility = 0;
             }
         }
     }
   else
     {
       Decision = DECISION_UNKNOWN;
       UndefinedPossibility = 0;
       SellPossibility = 0;
       BuyPossibility = 0;
     }
   return (Decision);
  }
  

//+------------------------------------------------------------------+
//| We calculate the statistics of the probabilities      --used to assign stop loss                            |
//+------------------------------------------------------------------+

int CalculatePossibilityStat()
  {
   int i;
   BuySucPossibilityCount = 0;
   SellSucPossibilityCount = 0;
   UndefinedSucPossibilityCount = 0;
//----
   BuyPossibilityCount = 0;
   SellPossibilityCount = 0;
   UndefinedPossibilityCount = 0;
// We calculate the average values of the probability
   BuySucPossibilityMid = 0;
   SellSucPossibilityMid = 0;
   UndefinedSucPossibilityMid = 0;
   BuyPossibilityQuality = 0;
   SellPossibilityQuality = 0;
   UndefinedPossibilityQuality = 0;
   PossibilityQuality = 0;
//----
   BuySucPossibilityQuality = 0;
   SellSucPossibilityQuality = 0;
   UndefinedSucPossibilityQuality = 0;
   PossibilitySucQuality = 0;
   for( i = 0 ; i < ModelingBars ; i ++ )
     {
       // We calculate the solution for this interval
       CalculatePossibility (i);
       // If the solution for value of i - was sold         
       if(Decision == DECISION_SELL )
           SellPossibilityQuality ++;   //means count of sell signals in modeling period        
       // If the solution for value of i - was bought
       if(Decision == DECISION_BUY )
           BuyPossibilityQuality ++;    //means count of buy signals in modeling period       
       // If the solution for value of i - is not determined
       if(Decision == DECISION_UNKNOWN )
           UndefinedPossibilityQuality ++;   //means count of unknown signals in modeling period        
       // The same estimations for the successful situations                 
       //
       if((BuyPossibility > Spread) || (SellPossibility > Spread) || 
          (UndefinedPossibility > Spread))   //means we have more market activity than spread 
         {
           if(Decision == DECISION_SELL)
               SellSucPossibilityQuality ++;        //means more market activity toward selling in modeling period             
           if(Decision == DECISION_BUY)
               BuySucPossibilityQuality ++;        //means more market activity toward buying in modeling period
           if(Decision == DECISION_UNKNOWN )
               UndefinedSucPossibilityQuality ++;      //means more unknown market activity in modeling period             
         }  
       // We calculate the average probabilities of the events
       // Probabilities of the purchase
       BuyPossibilityMid *= BuyPossibilityCount;//starts @ 0,0
       BuyPossibilityCount ++;      //adds 1 for each modeling period
       BuyPossibilityMid += BuyPossibility;//adds 0 to BP returns market activity unchanged
       if(BuyPossibilityCount != 0 )//condition is always positive as long as modeling 1 != 0
           BuyPossibilityMid /= BuyPossibilityCount; ///divisor = number of modeling passes    0 / passes always returns 0
       else                                           //repeats above logic for sell
           BuyPossibilityMid = 0;
       //  
       SellPossibilityMid *= SellPossibilityCount;
       SellPossibilityCount ++;
       SellPossibilityMid += SellPossibility;
       if(SellPossibilityCount != 0 )
           SellPossibilityMid /= SellPossibilityCount;
       else                                                    //repeats above logic for unknowns
           SellPossibilityMid = 0;
       // Probabilities of the indeterminate state
       UndefinedPossibilityMid *= UndefinedPossibilityCount;
       UndefinedPossibilityCount ++;
       UndefinedPossibilityMid += UndefinedPossibility;
       if(UndefinedPossibilityCount != 0)
           UndefinedPossibilityMid /= UndefinedPossibilityCount;
       else
           UndefinedPossibilityMid = 0;
       // We calculate the average probabilities of the successful events
       if(BuyPossibility > Spread)                        
         {
           BuySucPossibilityMid *= BuySucPossibilityCount;
           BuySucPossibilityCount ++;
           BuySucPossibilityMid += BuyPossibility;
           if(BuySucPossibilityCount != 0)
               BuySucPossibilityMid /= BuySucPossibilityCount;
           else
               BuySucPossibilityMid = 0;
         }
       if(SellPossibility > Spread)
         {
           SellSucPossibilityMid *= SellSucPossibilityCount;
           SellSucPossibilityCount ++;                 
           SellSucPossibilityMid += SellPossibility;
           if (SellSucPossibilityCount != 0)
              SellSucPossibilityMid /= SellSucPossibilityCount;
              else
                 SellSucPossibilityMid = 0;
         }
       if(UndefinedPossibility > Spread)
         {
           UndefinedSucPossibilityMid *= UndefinedSucPossibilityCount;
           UndefinedSucPossibilityCount ++;                 
           UndefinedSucPossibilityMid += UndefinedPossibility;
           if(UndefinedSucPossibilityCount != 0)
               UndefinedSucPossibilityMid /= UndefinedSucPossibilityCount;
           else
               UndefinedSucPossibilityMid = 0;
         }
     }
   if((UndefinedPossibilityQuality + SellPossibilityQuality + BuyPossibilityQuality)!= 0)
       PossibilityQuality = (SellPossibilityQuality + BuyPossibilityQuality) / 
       (UndefinedPossibilityQuality + SellPossibilityQuality + BuyPossibilityQuality);
   else             
       PossibilityQuality = 0;
   //    
   if((UndefinedSucPossibilityQuality + SellSucPossibilityQuality + 
      BuySucPossibilityQuality)!= 0)          
       PossibilitySucQuality = (SellSucPossibilityQuality + BuySucPossibilityQuality) / 
                                (UndefinedSucPossibilityQuality + SellSucPossibilityQuality + 
                                BuySucPossibilityQuality);
   else             
       PossibilitySucQuality = 0;
   return (0);
  }
  
//+------------------------------------------------------------------+
//|  We analyze state for decision making          --used to assign stop loss                    |
//+------------------------------------------------------------------+

int Patient1Decision()
  {
// We calculate the statistics of the period
   CalculatePossibilityStat();
// We calculate the probabilities of the accomplishment of the transactions
   CalculatePossibility(0);
   return(Decision);     
  }  
  

